;		TITLE  '(C) G3RFL 3cm POWERMETER 22/5/2014'			
;		V1	using dsPIC30F4012 Micro  28/3/2014
;		V2	3cm version low power 15/06/2014
;		V3	adding bar graph 7/10/2014
;----------------------------------------
;	       		28 PIN DIL 
;			dsPIC30F4012
;                     ______  ______
;		     |      \/      |
;   PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;	             |              |
;          AN0/RB0 --+ 2         27 +-- RB6  AVss
;	             |              |
;              RB1 --+ 3         26 +-- RE0  SDA DISPLAY		
;	             |              |
;              RB2 --+ 4         25 +-- RE1  SCL DISPLAY
;	             |              |
;    	       RB3 --+ 5         24 +-- RE2
;	             |              |
;   	       RB4 --+ 6         23 +-- RE3
;	             |              |
;              RB5 --+ 7         22 +-- RE4
;	             |              |
;              VSS  -+ 8         21 +-- RE5
;	             |              |
;              OSC --+ 9         20 +-- VDD
;	             |              |
;             RC15 --+ 10        19 +-- VSS
;	             |              |
;	      RC13 --+ 11        18 +-- RC7/PGC	
;	             |              |
;	      RC14 --+ 12        17 +-- RC6/PGD
;	             |              |
;              VDD --+ 13        16 +-- RE8
;	             |              |
;          CHOPPER/RD1 --+ 14        15 +-- RD0
;                    |______________|
;
;			PCF8574
;                     ______  ______
;		     |      \/      |
;               A0 --+ 1         16 +-- Vcc	
;	             |              |
;               A1 --+ 2         15 +-- SDA
;	             |              |
;               A2 --+ 3         14 +-- SCL		
;	             |              |
;            RS/P0 --+ 4         13 +-- /INT
;	             |              |
;    	     RW/P1 --+ 5         12 +-- P7/DB7
;	             |              |
;   	      E/P2 --+ 6         11 +-- P6/DB6
;	             |              |
;               P3 --+ 7         10 +-- P5/DB5
;	             |              |
;              GND  -+ 8          9 +-- P4/DB4
;	             |______________|
;	  
;-----------------------------------------------------------------------------
       .equ __30F4012, 1
        .include "p30f4012.inc"
;..............................................................................
;Program Specific Constants (literals used in code)
;..............................................................................
;-------------- global declarations ---------------------------------------
	.global __reset
	.global __T2Interrupt
	.global __T1Interrupt
	.global __IC2Interrupt
	.global __U1RXInterrupt
;..............................................................................
;Constants stored in Program space
;..............................................................................
        .section .myconstbuffer, psv
;..............................................................................
;Code Section in Program Memory
;-----------------------------------------------------------------------------
;Configuration bits:
	config __FOSC, CSW_FSCM_OFF & FRC_PLL4
	config __FWDT,WDT_OFF
	config __PBORPOR, PBOR_OFF & MCLR_EN
	config __FGS, CODE_PROT_OFF
;-----------------------------------------------------------------------------        
;define constant
;PORTB
;PORTC
;PORTD
	.equ	chop,#1
;PORTE
	.equ	sda,#0
	.equ	scl,#1
	.equ	rs,#0
	.equ	rw,#1
	.equ	e,#2
	.equ	db4,#4
	.equ	db5,#5
	.equ	db6,#6
	.equ	db7,#7
;-------------------------------------------
;define ram assignments
	.bss	intsreg,2	;temp stack register
	.bss	intwreg,2	;temp w register
	.bss	temp_pclath,2	;temp prog counter register
	.bss	temp1,2
	.bss	temp2,2
	.bss	digit1,2	
	.bss	digit2,2	
	.bss	digit3,2	
	.bss	digit4,2
	.bss	digit5,2
	.bss	digit6,2
	.bss	line_17,2	;2nd R0w display ram
	.bss	line_18,2
	.bss	line_19,2
	.bss	line_20,2
	.bss	line_21,2
	.bss	line_22,2
	.bss	line_23,2
	.bss	line_24,2
	.bss	line_25,2
	.bss	line_26,2
	.bss	line_27,2
	.bss	line_28,2
	.bss	line_29,2
	.bss	line_30,2
	.bss	line_31,2
	.bss	line_32,2
	.bss	control,2
	.bss	datbuff,2
	.bss	upper,2
	.bss	lower,2
	.bss	adval,2
	.bss	pwatts,2
	.bss	pmilliwatts,2
	.bss	toggle,2
	.bss	pdbm,2
	.bss	count,2
	.bss	block,2
	.bss	partial,2
	.bss	white,2
	.bss	blue,2
;---------------------------------------------------
	.text				;start of code
__reset:
        mov 	#__SP_init, W15       	;Initalize the Stack Pointer
        mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
        mov 	W0, SPLIM
        nop                     	;Add NOP to follow SPLIM initialization
	mov	#0xffff,w0		
	mov	w0,ADPCFG		;all digital I/O	
	clr	LATB
	clr	LATC
	clr	LATD
	clr	LATE
	bset    CORCON, #PSV              ;Enable Program Space Visibility	                                                                                                                                                
;----------------------- INITIALISATION ----------------
init:
	call	init_ports
	call	init_lcd
	call	init_ad
	call	start_LCD
	clr	digit1
	clr	digit2
	clr	digit3
	clr	digit4
	clr	digit5
	clr	digit6
	clr	control
	call	bar_data
	call	update_delay
;---------------------- MAIN ROUTINE ------------------
main:
	call	get_level
	call	CalculateDBm
	call	hex_dec_power
	call	hexdec_conv
	mov	digit1,w0	;digit1
	mov	w0,line_17
	mov	digit2,w0	;digit2
	mov	w0,line_18
	mov	digit3,w0
	add	#0x0030,w0
	mov	w0,line_19
	mov	#0x002e,w0	;"."
	mov	w0,line_20
	mov	digit4,w0
	add	#0x0030,w0
	mov	w0,line_21
	mov	digit5,w0
	add	#0x0030,w0
	mov	w0,line_22
	mov	digit6,w0
	add	#0x0030,w0
	mov	w0,line_23
	mov	#0x0057,w0	;"W"
	mov	w0,line_24
	mov	#0x0020,w0	;" "
	mov	w0,line_25
	mov	#0x2e,w0	;"."
	mov	w0,line_28
	mov	#0x0064,w0	;"d"
	mov	w0,line_30
	mov	#0x0042,w0	;"B"
	mov	w0,line_31
	mov	#0x006d,w0	;"m"
	mov	w0,line_32
	call	LCD_Line2
	call	send_buff2
	call	BarDisplay
	call	update_delay
	goto	main
;-----------------------------------------------------------
;	SUBROUTINES
;----------------------------------------------
BarDisplay:
        ;w6 = Adval (0-1023)
        ;Divide by 12.78125 is near enough for (0-80)

	mov	ADCBUF0,w6	;get A/D 10 bit value
	call	LCD_Line1
	clr	w0
      	sl      w6,#6,w6        ;Multiply by 64
     	mov     #818,w2 	;Divide by 818
   	repeat #17              ;
 	div.u   w6,w2           ;w0 = Scaled AD Value (0-80)

        mov     #5,w2           ;Divide by 5
        repeat  #17             ;
        div.u   w0,w2           ;
        mov     w0,white        ;white = number of white characters (0-16)
        mov     w1,partial      ;partial = number of partial columns in next character (0-4)
    	mov     #15,w2          ;
   	sub     w2,w0,w2        ;
  	mov     w2,blue 	;blue = number of blue characters (15 to -1)

1:      cp0     white           ;Output number of white blocks
        bra     z,2f            ;
        mov     #0x05,w0        ;
        call    bld_byte        ;
        dec     white           ;
        bra     1b              ;

2:  	inc     blue,wreg       ;Check if partial and blue blocks are required?
    	bra     z,4f            ;
   	mov     partial,w0      ;Output partial block
  	call    bld_byte        ;

3:      cp0     blue            ;Output number of blue blocks
       	bra     z,4f            ;
      	mov     #0x00,w0        ;
     	call    bld_byte        ;
    	dec     blue            ;
   	bra     3b              ;

4:      return                  ;All 16 characters Done
;------------------------------------
bar_data:
	call	LCD_Line1
	call	CG_ram		;set up cgram address 40H
	mov	#0x00,w0
	call	doit
	mov	#0x10,w0
	call	doit
	mov	#0x18,w0
	call	doit
	mov	#0x1c,w0
	call	doit
	mov	#0x1e,w0
	call	doit
	mov	#0x1f,w0
	call	doit
	return
doit:
	call	cg_write
	call	cg_write
	call	cg_write
	call	cg_write
	call	cg_write
	call	cg_write
	call	cg_write
	call	cg_write
	return
;-----------------------------------------------
get_level:	
	bset	ADCON1,#ADON	;start A/D convertion
notdone:
	btss	ADCON1,#DONE	;skip if done
	goto	notdone		;not ready yet

	mov	ADCBUF0,w0	;Get A/D value (0-1023~= 0-100W)
	mul.uu	w0,w0,w0	;Square and divide by 65536
	mov	#10465,w2	;Long Divide W1:W0 by 10465
	repeat	#17
	div.ud	w0,w2		;(W0=Watts. W1= Fractional Milliwatts)

	mov	w0,pwatts	;Save whole Watts (0-100)
	mov	#1000,w0	;Multiply Fraction by 1000
	mul.uu	w1,w0,w0
	repeat	#17		;Lo0ng Divide by 654
	div.ud	w0,w2
	mov	w0,pmilliwatts	;Save whole Milliwatts (0-999)

        mov             pwatts,w0       ;Divide 100W Result by 20 to give 5W Range
        mov             #20,w2          ;
        repeat  	#17             ;
        div.u           w0,w2           ;
        mov             w0,pwatts       ;
        mov             #1000,w2        ;
        mul.uu  	w1,w2,w0        ;
        mov             pmilliwatts,w2  ;
        add             w2,w0,w0        ;
        addc            w1,#0,w1        ;
        mov             #20,w2          ;
        repeat		#17             ;
        div.ud  	w0,w2           ;
   	mov             w0,pmilliwatts 
	return                                     
;-------------------------------------
CalculateDBm:
	clr	pdbm            ;Clear dBm Result
	mov     pwatts,w0       ;Multiply Watts by 1000
	mov     #1000,w1        ;
	mul.uu  w0,w1,w0        ;
	mov     pmilliwatts,w2  ;And Add Milliwatts
	add     w2,w0,w0        ;
	addc    w1,#0,w1        ;W1:W0 Holds Power in binary milliwatts
	clr	w5		;w1:w0.w5 holds power in binary milliwatts
	mov     #64044,w6       ;Divide by 1.258927714 (~1dB)
1:	mul.uu  w1,w6,w2        ;
	mul.uu  w0,w6,w0        ;
	mul.uu	w5,w6,w4
	add	w0,w5,w5
	addc    w2,w1,w0
	addc	w3,#0,w1	;w1:w0.w5 now valid
	inc     pdbm            ;No - Increment dBm Result
	ior	w0,w1,w2	;is w1:w0=0?
	bra	nz,1b            ;no Loop Again
	cp	w5,w6		;yes round down if required
	bra	gtu,2f
	dec	pdbm
2:	return			;return job done
;---------------------------------------------------
hex_dec_power:
	mov	pdbm,w0
	mov     #100,w2		;100
	repeat	#17
	div.u   w0,w2
	add	#0x30,w0
	mov	#0x30,w4
	cp	w0,w4
	bra	nz,no
	mov	#0x20,w0
no:
	mov	w0,line_26
	mov     #10,w2		;10
	repeat	#17
	div.u   w1,w2
	add	#0x30,w0
	mov	w0,line_27		
	add	#0x30,w1
	mov	w1,line_29	
	return
;------------------------- 
hexdec_conv:
	mov	#0x00,w4
	mov	pwatts,w1
	mov     #100,w2		;100
	repeat	#17
	div.u   w1,w2
	cp	w0,w4
	bra	nz,noo
	mov	#0x20,w0
	bra	nnno
noo:
	add	#0x30,w0
nnno:
	mov	w0,digit1
	mov	#10,w2		;10
	repeat	#17
	div.u	w1,w2
	cp	w0,w4
	bra	nz,nooo
	mov	digit1,w4
	mov	#0x31,w5
	cp	w4,w5
	bra	z,nooo
	mov	#0x20,w0
	bra	nnoo
nooo:
	add	#0x30,w0
nnoo:
	mov	w0,digit2
	btsc	digit1,#0
	add	#9,w0		
	mov	w1,digit3
	mov	pmilliwatts,w1
	mov     #100,w2		;100
	repeat	#17
	div.u   w1,w2
	mov	w0,digit4
	mov	#10,w2		;10
	repeat	#17
	div.u	w1,w2
	mov	w0,digit5
	mov	w1,digit6
	return
;------------------ INIT LCD START ADDRESS -------------------
CG_ram:
	mov	#0x40,w0	;set to control register
	call	bld_command
	return
LCD_Line1:
	mov	#0x80,w0	;set to control register
	call	bld_command
	return
LCD_Line2:
	mov	#0xc0,w0	;set to control register
	call	bld_command
	return
;------------------ INIT LCD SETTUP -------------------
init_lcd_tab:
	bra	w0	
	retlw	#0x38,w0	;0
	retlw	#0x38,w0	;1		;30
	retlw	#0x04,w0	;command
	retlw	#0x08,w0	;turn lcd on	;08

	retlw	#0x04,w0	;4		;02
	retlw	#0x00,w0	;5
	retlw	#0x24,w0	;6
	retlw	#0x00,w0	;sets up two line operation

	retlw	#0x1c,w0	;8
	retlw	#0x08,w0	;9
	retlw	#0x0d,w0	;control
	retlw	#0x09,w0	;b
;-----------------------------------------------------
init_lcd:
;		01	REGISTER SELECT
;		02	READ/WRITE SELECT
;		04	ENABLE BIT
	call	start_LCD
	call	header_LCD		;send i2c address "7E"
	mov	#0x0000,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;set DL to be 4 bit
	call	sendlcd
	mov	#0x0001,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;1
	call	sendlcd
	mov	#0x0002,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;2
	call	sendlcd
	mov	#0x0003,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;3
	call	sendlcd
	mov	#0x0004,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;4
	call	sendlcd
	mov	#0x0005,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;5
	call	sendlcd
	mov	#0x0006,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;6
	call	sendlcd
	mov	#0x0007,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;7
	call	sendlcd
	mov	#0x0008,w0
	call	init_lcd_tab 
	mov	w0,datbuff	;8
	call	sendlcd
	mov	#0x0009,w0
	call	init_lcd_tab
 	mov	w0,datbuff	;9
	call	sendlcd
	mov	#0x000a,w0
	call	init_lcd_tab
 	mov	w0,datbuff	;a
	call	sendlcd
	mov	#0x000b,w0
	call	init_lcd_tab
 	mov	w0,datbuff	;b
	call	sendlcd
	return
;------------------------------
cg_write:
bld_byte:
	push	w0
	mov	w0,upper
	sl	w0,#4,w0
	mov	w0,lower
	bset	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bset	upper,#0
	goto	ext
;------------------------------
bld_command:
	push	w0
	mov	w0,upper
	sl	w0,#4,w0
	mov	w0,lower
	bclr	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bclr	upper,#0
ext:
	bclr	upper,#1
	bset	upper,#2
	bset	upper,#3
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	upper,#2
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	lower,#2
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd	
	pop	w0
	return
;------------------------------
header_LCD:
	mov	#0x7e,w0	;lcd address
	mov	w0,datbuff
	call	sendlcd		;send 7e address to i2c chip
	nop
	return
;---------------------------------
sendlcd:
	mov	datbuff,w0	;saved data
	mov	w0,temp2	;this will get destroyed
	mov	#0x08,w0	;send 8 bits
	mov	w0,temp1
send8_i2c:
	bclr	LATE,#sda
	btsc	temp2,#0x07
	bset	LATE,#sda	;set data bit	
	sl	temp2	
	call	i2c_clk
	dec	temp1
	bra	nz,send8_i2c
	bset	LATE,#sda
	call	i2c_clk		;ack bit clock
	return
;----------------------
start_LCD:
	bclr	LATE,#sda
	nop
	nop
	nop
	bclr	LATE,#scl	;start condition
	return
;----------------------
stop_LCD:
	bset	LATE,#scl
	nop
	nop
	nop
	bset	LATE,#sda	;stop condition
	return
;---------------------------------------------------------
i2c_clk:
	bset	LATE,#scl
	nop
	nop
	nop
	nop
	nop
	nop
	bclr	LATE,#scl	;synth clock pulse
	return
;-------------------- init the A/D ---------------------------
init_ad:
	mov	#0xfff8,W0		
	mov	W0,ADPCFG		;3 analogue rest digital
	mov	#0x80ec,w0
	mov	w0,ADCON1
	mov	#0x0100,w0
	mov	w0,ADCON2
	mov	#0x0001,w0
	mov	w0,ADCON3
	mov	#0x0000,w0
	mov	w0,ADCHS
	return
;------------------------ load buffers to display ram --------
send_buff2:
	call	start_LCD
	mov	line_17,w0
	call	bld_byte
	mov	line_18,w0
	call	bld_byte
	mov	line_19,w0
	call	bld_byte
	mov	line_20,w0
	call	bld_byte
	mov	line_21,w0
	call	bld_byte
	mov	line_22,w0
	call	bld_byte
	mov	line_23,w0
	call	bld_byte
	mov	line_24,w0
	call	bld_byte
	mov	line_25,w0
	call	bld_byte
	mov	line_26,w0
	call	bld_byte
	mov	line_27,w0
	call	bld_byte
	mov	line_28,w0
	call	bld_byte
	mov	line_29,w0
	call	bld_byte
	mov	line_30,w0
	call	bld_byte
	mov	line_31,w0
	call	bld_byte
	mov	line_32,w0
	call	bld_byte
	return
;--------------------------- SET UP PORTS -----------------
init_ports:
	clr	PTCON
	clr	PWMCON1
	clr	OVDCON
	clr	LATB
	mov	#0x0000,w0	;0=output
	mov	w0,TRISC
	mov	#0x0001,w0
	mov	w0,TRISB	;1=input
	mov	#0x0000,w0
	mov	w0,TRISD
	mov	#0x3c,w0
	mov	w0,TRISE
	call	stop_LCD
	return
;---------------- display update delay ----------
update_delay:
	mov	#0x60,w3	
big:
	repeat	#16000
	nop
	dec	w3,w3
	bra	nz,big
	return
;--------------------------------------------
delay:

	repeat	#16000
	nop
	repeat	#16000
	nop
	repeat	#16000
	nop



	return
;---------------------------------------------------
	.end

